 
import 'package:mongo_dart/mongo_dart.dart';
import 'package:origami_database/models/actionModel.dart';
import 'package:origami_database/models/odataModel.dart';
import 'package:origami_database/models/queryModel.dart';
import 'package:origamicore/models/activator.dart';
import 'package:origamicore/models/messageModel.dart';
import 'package:origamicore/models/routeModule.dart';
import 'package:origamicore/models/serializedObject.dart';
import 'package:origamicore/routing/routeResponse.dart';
import 'package:origamicore/routing/router.dart';

class DatabaseRoute<T extends SerializedObject> extends RouteMudule
{
  MessageModel _model=MessageModel();
  String service='';
  Future<List<T>> search(String context,String table,QueryModel query,[Odata odata]) async
  { 
    if(query.where!=null)
    {
      if(query.where is SelectorBuilder )
      {
        query.where=(query.where as SelectorBuilder). map['\$query'];
      }
    }
    if(odata!=null)
    {
      var newWhere=<String,dynamic>{}; 
      if(query.where!=null)
      { 
        if(odata.filter!=null)
        {
          newWhere={
            '\$and':[
              odata.filter,
              query.where
            ]
          };
        }
        else
        {
          newWhere=query.where;
        }
      }
      else
      {
        if(odata.filter!=null)
        {
          newWhere=odata.filter;
        }
      }
      query.where=newWhere;
      if(odata.skip!=null)
      {
        query.skip=odata.skip;
      }
      if(odata.top!=null)
      {
        if(query.top!=null)
        {
          if(odata.top<query.top)
          {
            query.top=odata.top;
          }
        }
        else
        {
          query.top=odata.top;
        }
      }
    }
    _model=MessageModel(internalData: {'name':context,'table':table},data: {'query':query.toJson()});
    service='search';
    var list=<T>[];
    var dt = await run(); 
    if(dt.response?.data['value']!=null)
    {
      for(var a in dt.response?.data['value'])
      {
        SerializedObject t = Activator.createInstance(T);
        t.fromJson(a);
        list.add(t as T);
      }
    } 
    return list;
  }
  Future<T> searchOne(String context,String table,QueryModel query,[Odata odata]) async
  {
    _model=MessageModel(internalData: {'name':context,'table':table},data: {'query':query.toJson()});
    service='searchOne';
    var dt = await run();
    SerializedObject t = Activator.createInstance(T);
    if(dt.response?.data!=null)
    {
      t.fromJson(dt.response?.data);
      return t as T;
    }
    return null;
  }
  Future<DatabaseActionModel> save(String context,String table,List<String>keys,dynamic object) async
  {
    if(keys.isEmpty)keys=['_id'];
    if(object is SerializedObject)
    {
      object =(object as SerializedObject).toJson();
    }
    _model=MessageModel(internalData: {'name':context,'table':table},data: {'keys':keys,'object':object});
    service='save';
    var dt = await run();
    return DatabaseActionModel.fromJson(dt.response?.data);
  }
  Future<DatabaseActionModel> deleteOne(String context,String table,List<String>keys,dynamic object) async
  {
    _model=MessageModel(internalData: {'name':context,'table':table},data: {'keys':keys,'object':object});
    service='deleteOne';
    var dt = await run();
    return DatabaseActionModel.fromJson(dt.response?.data);
  }
  @override
  Future<RouteResponse> run() { 
    return Router.run('database', service, _model); 
  }

}